#if defined(__APPLE_CC__)
#include <GLUT/glut.h>
#else
#include <GL/gl.h>
#include <GL/glut.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include "sys.h"

int SYS_fenLong = 580;
int SYS_fenHaut = 450;
int SYS_fenPosX = -1;
int SYS_fenPosY = -1;
int SYS_fenMode = GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH;
char *SYS_fenName = "CABVAT";
void (*SYS_displayFunc)(void)=NULL;
void (*SYS_reshapeFunc)(int width, int height)=NULL;
void (*SYS_mouseFunc)(int button, int state, int x, int y)=NULL;
void (*SYS_motionFunc)(int x, int y)=NULL;
void (*SYS_idleFunc)(void)=NULL;
void (*SYS_timerFunc)(int value)=NULL;
void (*SYS_keyFunc)(unsigned char c, int x, int y)=NULL;
void (*SYS_keyUpFunc)(unsigned char c, int x, int y)=NULL;

int topFenetreNo;

void monReshapeFunc(int w, int h) {
	SYS_fenLong=w;
	SYS_fenHaut=h;
	glViewport(0,0,w,h);
}

void SYS_init(int *nbarg, char **arg) {
	glutInit(nbarg,arg);
	glutInitWindowSize(SYS_fenLong, SYS_fenHaut);
	glutInitWindowPosition(SYS_fenPosX, SYS_fenPosY);
	glutInitDisplayMode(SYS_fenMode);
	topFenetreNo = glutCreateWindow(SYS_fenName);
	
	glClearColor(0.18, 0.28, 0.28, 0.0);
	glEnable(GL_LIGHTING);

	if (SYS_displayFunc) glutDisplayFunc(SYS_displayFunc);
	if (SYS_mouseFunc) glutMouseFunc(SYS_mouseFunc);
	if (SYS_motionFunc) {
		glutMotionFunc(SYS_motionFunc);
		glutPassiveMotionFunc(SYS_motionFunc);
	}
	if (SYS_keyFunc) glutKeyboardFunc(SYS_keyFunc);
	if (SYS_keyUpFunc) glutKeyboardUpFunc(SYS_keyUpFunc);
	glutReshapeFunc(&monReshapeFunc);
	glutIgnoreKeyRepeat(1);
	if (SYS_idleFunc) glutIdleFunc(SYS_idleFunc);
}

void SYS_run() {
	glutMainLoop();
}

int SYS_timer(unsigned int msecs, void (*timerFunc)(int), int value) {
	glutTimerFunc(msecs, timerFunc, value);
	return 1;
}


void SYS_affiche() {
	glutSwapBuffers();
}

void SYS_reaffiche() {
	glutPostRedisplay();
}

void SYS_efface(int buffers) {
	glClear(buffers);
}

